let settings;
let propertiesLogData;

// TODO CLEAN UP
function initializeAccount(accountLog, propertiesLog) {
    settings = accountLog;
    propertiesLogData = propertiesLog;
    AddToServerOptions(propertiesLog);
    AddToUserOptions(propertiesLog);
    AddToNotificationsOptions();
    AddToSSLOptions();
    AddToDebuggingOptions();
    AddToProviderOptions(propertiesLog);


    let Service = null;
    let NormalizerService = null;

    Service = Services(
        PBConstants.BASE_API_URL,
        PBConstants.MARKET_CAP_API_URL,
        PBConstants.CURRENCIES_API_URL,
        PBConstants.GLOBAL_MARKET_CAP_API_URL
    );
    NormalizerService = Service.Normalizer;

    let settingsDetails = NormalizerService.settingsDetails(propertiesLog);
    if (propertiesLog.hasOwnProperty('licenseType')) {
        // To only execute setLogOutButton setLogOutButton when we have data from monitoring/data API.
        setUserSettingButtons(settingsDetails);
        setTestSwitcherView(accountLog);
    }

    // To handle api logs viewer to have only one scrollbar.
    $('a[href="#logs"]').on('click', function () {
        $(window).resize();
    });

    PopulatePTA();
}

function PopulatePTA() {
    jQuery.get(THE_BASE_URL + '/api/v2/assistant/list', function (response) {
        AddToPTA(response);
    });
}

function setTestSwitcherView(monitoringData) {
    // if (monitoringData.EXCHANGE.toLowerCase() === 'bitmex') {
    //     $('.test-net-switcher').show();
    //     $('.test-mode-switcher').hide();
    // } else {
    //     $('.test-net-switcher').hide();
    //     $('.test-mode-switcher').show();
    // }
}

// Disabling buttons in User Settings tab based on monitoring data API values.
function setUserSettingButtons(settingsDetail) {
    let $stopBtnContainer = $('#btnStopContainer');
    let $changePswrdBtnContainer = $('#btnChngePswrdContainer');
    let $settingsConfigBtnsContainer = $('#advConfigTgleContainer, #buySellBtnTgleContainer,' +
        '#activeConfigSwitchContainer, #btnResetContainer, #somoSwitchContainer, #btnSetUpContainer');
    let $settingsBtnsContainer = $('#btnLogoutContainer');

    if (!settingsDetail) {
        return;
    }

    let settingsBtns = [
        {
            element: $settingsBtnsContainer,
            enable: settingsDetail.enableAllBtns,
            tooltip: settingsDetail.disableBtnTooltip
        },
        {
            element: $settingsConfigBtnsContainer,
            enable: settingsDetail.enableConfigBtns,
            tooltip: settingsDetail.disableTopBtnsTooltip
        },
        {
            element: $stopBtnContainer,
            enable: settingsDetail.enableStopPTBtn,
            tooltip: settingsDetail.disableBtnTooltip || 'settingInfo.noEnableShutdown.title'
        },
        {
            element: $changePswrdBtnContainer,
            enable: settingsDetail.enableChangePasswordBtn,
            tooltip: settingsDetail.disableBtnTooltip || 'settingInfo.incorrectRole.title'
        }
    ];
    // Loop over settings buttons and toggle disable functionality based on settings.
    for (let i = 0; i < settingsBtns.length; i++) {
        let currentElement = settingsBtns[i];
        toggleBtn(currentElement.element, currentElement.enable,
            currentElement.tooltip);
    }

    function toggleBtn($btnContainer, enable, label, labelParams) {
        if (enable) {
            $btnContainer.removeClass('disabled').attr('data-original-title', '');
            $btnContainer
                .find('.btn, input, select')
                .removeClass('disabled')
                .attr('disabled', false);
        } else {
            $btnContainer
                .addClass('disabled')
                .attr('data-original-title', i18next.t(label, labelParams));
            $btnContainer
                .find('.btn, input, select')
                .addClass('disabled')
                .attr('disabled', true);
        }
    }
}

function AddToServerOptions(propertiesLog) {
    if (!propertiesLog.hasOwnProperty('licenseType')) {
        return;
    }

    document.getElementById("Port").value = parseInt(settings.PORT || 8081);
    document.getElementById("SiteName").value = settings.SITE_NAME || '';
    document.getElementById("ApiToken").value = settings.TOKEN || '';
    document.getElementById("PTFeederLocation").value = settings.PTFEEDER || '';

    if (settings.TEST_MODE === "true") {
        document.getElementById("TestMode").checked = true;
        document.getElementById("TestMode").value = true;
    }
    if (settings.TEST_NET === "true") {
        document.getElementById("TestNet").checked = true;
        document.getElementById("TestNet").value = true;
    }

    if (settings.MARGIN_TRADING === "true") {
        document.getElementById("MarginTrading").checked = true;
        document.getElementById("MarginTrading").value = true;
    }

    if (settings.EXCHANGE === "BINANCE") {
        document.getElementById("MarginTrading").parentElement.classList.remove("hide")
    }

    if (settings.EXCHANGE === "BITMEX" && settings.TEST_NET === "true") {
        document.getElementById("TestNet").parentElement.classList.remove("hide")
    }

    if (settings.TEST_MODE === "true" && settings.EXCHANGE === "BITMEX") {
        document.getElementById("TestNet").parentElement.classList.add("hide");
    }

    document.getElementById("ServerAddress").value = settings.SERVER_ADDRESS || '';
    document.getElementById("ServerContextPath").value = settings.CONTEXT_PATH || '';
    document.getElementById("ExchangeURL").value = settings.EXCHANGE_URL || '';
    document.getElementById("LogHistory").value = parseInt(settings.LOG_HISTORY || 0);

}

function AddToUserOptions(propertiesLog) {
    if (!propertiesLog.hasOwnProperty('isMarketOrderSupported')) {
        return;
    }
    if (settings.TEST_MODE === "true") {
        document.getElementById('TestModeBalanceParent').classList.remove('hide');
    } else {
        document.getElementById('TestModeBalanceParent').classList.add('hide');
        document.getElementById('accountStartBalanceParent').parentElement.classList.remove('col-md-6');
        document.getElementById('accountStartBalanceParent').parentElement.classList.add('col-md-12');
    }

    document.getElementById("StartBalance").value = settings.START_BALANCE || 0;
    document.getElementById("TestModeBalance").value = settings.TEST_MODE_BALANCE || 0;
    document.getElementById("ProfitCalculationMethod").value = settings.PCM;
    document.getElementById("TradingDelay").value = settings.START_TRADING_DELAY || '';
    document.getElementById("Timezone").value = settings.TIMEZONE;
    document.getElementById("Language").value = settings.LANGUAGE;
    document.getElementById("Skin").value = settings.SKIN;
    document.getElementById("Currency").value = settings.CURRENCY;


    let buyType = document.getElementById('BuyType');
    let buyTypeOptIOC = document.createElement('option');
    buyTypeOptIOC.appendChild(document.createTextNode('IOC'));
    buyTypeOptIOC.value = 'IOC';
    buyType.appendChild(buyTypeOptIOC);
    if(propertiesLog.isMarketOrderSupported) {
        let buyTypeOptMarket = document.createElement('option');
        buyTypeOptMarket.appendChild(document.createTextNode('MARKET'));
        buyTypeOptMarket.value = 'MARKET';
        buyType.appendChild(buyTypeOptMarket);
    }


    let sellType = document.getElementById('SellType');
    let sellTypeOptIOC = document.createElement('option');
    sellTypeOptIOC.appendChild(document.createTextNode('IOC'));
    sellTypeOptIOC.value = 'IOC';
    sellType.appendChild(sellTypeOptIOC);
    if(propertiesLog.isMarketOrderSupported) {
        let sellTypeOptMarket = document.createElement('option');
        sellTypeOptMarket.appendChild(document.createTextNode('MARKET'));
        sellTypeOptMarket.value = 'MARKET';
        sellType.appendChild(sellTypeOptMarket);
    }

    document.getElementById("SellType").value = settings.SELL_ORDER_TYPE_OR_TIME;
    document.getElementById("BuyType").value = settings.BUY_ORDER_TYPE_OR_TIME;

    if (settings.DISPLAY_ADVANCED_STATS === "true") {
        document.getElementById("AdvStats").checked = true;
        document.getElementById("AdvStats").value = true;
    }
    if (settings.OFFLINE_CONFIG === "true") {
        document.getElementById("DisableOfflineConfig").parentElement.classList.remove("hide");
        document.getElementById("AdvStats").parentElement.classList.remove("offset-md-2");

        document.getElementById("DisableOfflineConfig").checked = true;
        document.getElementById("DisableOfflineConfig").value = true;
    }
    if (settings.NOTIFICATION_BELL === "true") {
        document.getElementById("DisableNotifications").checked = true;
        document.getElementById("DisableNotifications").value = true;
    }

    if (settings.BROWSER === "true") {
        document.getElementById("OpenBrowser").checked = true;
        document.getElementById("OpenBrowser").value = true;
    }
}

function AddToNotificationsOptions() {
    if (settings.ADVANCED_NOTIFICATIONS === "true") {
        let element = document.querySelectorAll('.ptn-view');
        for (let i = 0; i < element.length; i++) {
            element[i].classList.remove('hide');
        }

        document.getElementById("AdvancedNotifications").checked = true;
        document.getElementById("AdvancedNotifications").value = true;

    } else {
        document.getElementById("AdvancedNotifications").checked = false;
        document.getElementById("AdvancedNotifications").value = false;
        let element = document.querySelectorAll('.ptn-view');
        for (let i = 0; i < element.length; i++) {
            element[i].classList.add('hide');
        }
    }

    let telegramBuyMessage = "<b>Bought {market} </b> ({dcaCount})\nInstance: {instanceName}\nStrategies: {strategies}\nQuantity: {quantity}\nRate: {rate}\nAvg_price: {avgCost}\nTotal: {total} ({dcaCount})\nProfit: {percentage}";
    let telegramSellMessage = "<b>Sold {market} </b> ({dcaCount})\nInstance: {instanceName}\nStrategies: {strategies}\nQuantity: {quantity}\nRate: {rate}\nAvg_price: {avgCost}\nTotal: {total} ({dcaCount})\nProfit: {profit} ({dollar})\nBought_on: {boughtDate}\nPercentage: {percentage}";
    let telegramErrorMessage = '';

    // Telegram Instance 1
    document.getElementById("TelegramBotToken1").value = settings.TELEGRAM_TOKEN_1 || '';
    document.getElementById("TelegramBotChatID1").value = settings.TELEGRAM_CHAT_1 || '';
    // Telegram PTN 1
    document.getElementById("TelegramSellMessage1").value = settings.PTN_TELEGRAM_SELL_MESSAGE_1 || telegramSellMessage;
    document.getElementById("TelegramBuyMessage1").value = settings.PTN_TELEGRAM_BUY_MESSAGE_1 || telegramBuyMessage;
    document.getElementById("TelegramErrorMessage1").value = settings.PTN_TELEGRAM_ERROR_MESSAGES_FILTER_1 || telegramErrorMessage;

    if (settings.PTN_TELEGRAM_SELL_MESSAGE_ENABLED_1 === "true") {
        document.getElementById("TelegramSellMessageEnabled1").checked = true;
        document.getElementById("TelegramSellMessageEnabled1").value = true;
    }
    if (settings.PTN_TELEGRAM_BUY_MESSAGE_ENABLED_1 === "true") {
        document.getElementById("TelegramBuyMessageEnabled1").checked = true;
        document.getElementById("TelegramBuyMessageEnabled1").value = true;
    }
    if (settings.PTN_TELEGRAM_ERROR_MESSAGES_ENABLED_1 === "true") {
        document.getElementById("TelegramErrorMessageEnabled1").checked = true;
        document.getElementById("TelegramErrorMessageEnabled1").value = true;
    }
    if (settings.PTN_TELEGRAM_COMMANDS_ENABLED_1 === "true") {
        document.getElementById("TelegramCommandMessageEnabled1").checked = true;
        document.getElementById("TelegramCommandMessageEnabled1").value = true;
    }

    // Telegram Instance 2
    document.getElementById("TelegramBotToken2").value = settings.TELEGRAM_TOKEN_2 || '';
    document.getElementById("TelegramBotChatID2").value = settings.TELEGRAM_CHAT_2 || '';
    // Telegram PTN 2
    document.getElementById("TelegramSellMessage2").value = settings.PTN_TELEGRAM_SELL_MESSAGE_2 || telegramSellMessage;
    document.getElementById("TelegramBuyMessage2").value = settings.PTN_TELEGRAM_BUY_MESSAGE_2 || telegramBuyMessage;
    document.getElementById("TelegramErrorMessage2").value = settings.PTN_TELEGRAM_ERROR_MESSAGES_FILTER_2 || telegramErrorMessage;

    if (settings.PTN_TELEGRAM_SELL_MESSAGE_ENABLED_2 === "true") {
        document.getElementById("TelegramSellMessageEnabled2").checked = true;
        document.getElementById("TelegramSellMessageEnabled2").value = true;
    }
    if (settings.PTN_TELEGRAM_BUY_MESSAGE_ENABLED_2 === "true") {
        document.getElementById("TelegramBuyMessageEnabled2").checked = true;
        document.getElementById("TelegramBuyMessageEnabled2").value = true;
    }
    if (settings.PTN_TELEGRAM_ERROR_MESSAGES_ENABLED_2 === "true") {
        document.getElementById("TelegramErrorMessageEnabled2").checked = true;
        document.getElementById("TelegramErrorMessageEnabled2").value = true;
    }
    if (settings.PTN_TELEGRAM_COMMANDS_ENABLED_2 === "true") {
        document.getElementById("TelegramCommandMessageEnabled2").checked = true;
        document.getElementById("TelegramCommandMessageEnabled2").value = true;
    }

    // Telegram Generics
    if (settings.TELEGRAM_SIGNAL_NOTIFICATION === "true") {
        document.getElementById("TelegramSignalNotification").checked = true;
        document.getElementById("TelegramSignalNotification").value = true;
    }
    if (settings.TELEGRAM_STARTUP_NOTIFICATION === "true") {
        document.getElementById("TelegramStartupNotification").checked = true;
        document.getElementById("TelegramStartupNotification").value = true;
    }
    if (settings.TELEGRAM_SHUTDOWN_NOTIFICATION === "true") {
        document.getElementById("TelegramShutdownNotification").checked = true;
        document.getElementById("TelegramShutdownNotification").value = true;
    }

    let discordBuyMessage = "**Bought {market} ** ({dcaCount})\n```ml\nInstance:   {instanceName}\nStrategies: {strategies}\nQuantity:   {quantity}\nRate:       {rate}\nAvg_price:  {avgCost}\nTotal:      {total} ({dcaCount})\nProfit:     {percentage}```";
    let discordSellMessage = "**Sold {market} ** ({dcaCount})\n```ml\nInstance:   {instanceName}\nStrategies: {strategies}\nQuantity:   {quantity}\nRate:       {rate}\nAvg_price:  {avgCost}\nTotal:      {total} ({dcaCount})\nProfit:     {profit} ({dollar})\nBought_on:  {boughtDate}\nPercentage: {percentage}```";
    let discordErrorMessage = "";
    // Discord Instance 1
    document.getElementById("DiscordBotToken1").value = settings.DISCORD_TOKEN_1 || '';
    document.getElementById("DiscordBotChatID1").value = settings.DISCORD_CHAT_1 || '';
    // Discord PTN 1
    document.getElementById("DiscordSellMessage1").value = settings.PTN_DISCORD_SELL_MESSAGE_1 || discordSellMessage;
    document.getElementById("DiscordBuyMessage1").value = settings.PTN_DISCORD_BUY_MESSAGE_1 || discordBuyMessage;
    document.getElementById("DiscordErrorMessage1").value = settings.PTN_DISCORD_ERROR_MESSAGES_FILTER_1 || discordErrorMessage;

    if (settings.PTN_DISCORD_SELL_MESSAGE_ENABLED_1 === "true") {
        document.getElementById("DiscordSellMessageEnabled1").checked = true;
        document.getElementById("DiscordSellMessageEnabled1").value = true;
    }
    if (settings.PTN_DISCORD_BUY_MESSAGE_ENABLED_1 === "true") {
        document.getElementById("DiscordBuyMessageEnabled1").checked = true;
        document.getElementById("DiscordBuyMessageEnabled1").value = true;
    }
    if (settings.PTN_DISCORD_ERROR_MESSAGES_ENABLED_1 === "true") {
        document.getElementById("DiscordErrorMessageEnabled1").checked = true;
        document.getElementById("DiscordErrorMessageEnabled1").value = true;
    }
    if (settings.PTN_DISCORD_COMMANDS_ENABLED_1 === "true") {
        document.getElementById("DiscordCommandMessageEnabled1").checked = true;
        document.getElementById("DiscordCommandMessageEnabled1").value = true;
    }

    // Discord Instance 2
    document.getElementById("DiscordBotToken2").value = settings.DISCORD_TOKEN_2 || '';
    document.getElementById("DiscordBotChatID2").value = settings.DISCORD_CHAT_2 || '';
    // Discord PTN 2
    document.getElementById("DiscordSellMessage2").value = settings.PTN_DISCORD_SELL_MESSAGE_2 || discordSellMessage;
    document.getElementById("DiscordBuyMessage2").value = settings.PTN_DISCORD_BUY_MESSAGE_2 || discordBuyMessage;
    document.getElementById("DiscordErrorMessage2").value = settings.PTN_DISCORD_ERROR_MESSAGES_FILTER_2 || discordErrorMessage;

    if (settings.PTN_DISCORD_SELL_MESSAGE_ENABLED_2 === "true") {
        document.getElementById("DiscordSellMessageEnabled2").checked = true;
        document.getElementById("DiscordSellMessageEnabled2").value = true;
    }
    if (settings.PTN_DISCORD_BUY_MESSAGE_ENABLED_2 === "true") {
        document.getElementById("DiscordBuyMessageEnabled2").checked = true;
        document.getElementById("DiscordBuyMessageEnabled2").value = true;
    }
    if (settings.PTN_DISCORD_ERROR_MESSAGES_ENABLED_2 === "true") {
        document.getElementById("DiscordErrorMessageEnabled2").checked = true;
        document.getElementById("DiscordErrorMessageEnabled2").value = true;
    }
    if (settings.PTN_DISCORD_COMMANDS_ENABLED_2 === "true") {
        document.getElementById("DiscordCommandMessageEnabled2").checked = true;
        document.getElementById("DiscordCommandMessageEnabled2").value = true;
    }

    // Discord Generics
    document.getElementById("DiscordNewSignalChannel").value = settings.DISCORD_SIGNAL_NOTIFICATION_CHANNEL || '';

    if (settings.DISCORD_SIGNAL_NOTIFICATION === "true") {
        document.getElementById("DiscordSignalNotification").checked = true;
        document.getElementById("DiscordSignalNotification").value = true;
    }
    if (settings.DISCORD_STARTUP_NOTIFICATION === "true") {
        document.getElementById("DiscordStartupNotification").checked = true;
        document.getElementById("DiscordStartupNotification").value = true;
    }
    if (settings.DISCORD_SHUTDOWN_NOTIFICATION === "true") {
        document.getElementById("DiscordShutdownNotification").checked = true;
        document.getElementById("DiscordShutdownNotification").value = true;
    }

}

function AddToDebuggingOptions() {
}

function AddToSSLOptions() {
    document.getElementById("SSLKeyStore").value = settings.SSL_KEY_STORE || '';
    document.getElementById("SSLKeyStorePassword").value = settings.SSL_KEY_STORE_PASSWORD || '';
    document.getElementById("SSLKeyPassword").value = settings.SSL_KEY_PASSWORD || '';
    document.getElementById("SSLKeyStoreType").value = settings.SSL_KEY_STORE_TYPE || '';
    document.getElementById("SSLKeyAlias").value = settings.SSL_KEY_ALIAS || '';
}

function AddToProviderOptions(propertiesLog) {
    if (!propertiesLog.hasOwnProperty('availableSignalProviders')) {
        return;
    }
    let signalProviderElement = $('#signalProviders');

    if(signalProviderElement.length){
        signalProviderElement.children().remove();
    }

    let availableProviders = JSON.parse(propertiesLog.availableSignalProviders);
    let enabledProvidersArr = (settings.SELECTED_SIGNAL_PROVIDERS || '').split(",");

    if (availableProviders.length) {
        availableProviders.forEach(function (product) {

            signalProviderElement.append('<div class="col-md-6 signalProviders" id="'+ product +'-lang">' +
                '<h5 class="text-center">' + product + '</h5>' +
                '<input class="tgl tgl-skewed" type="checkbox" data-val="false" value="false" name="' + product + '" id="' + product + '">' +
                '<label class="tgl-btn mainswitch large text-center" style="width:100%" data-tg-off="Disabled" data-tg-on="Enabled"  for="' + product + '"></label>' +
                '</div>');

            if (enabledProvidersArr.includes(product)) {
                document.getElementById(product).checked = true;
                document.getElementById(product).value = true;
            }
        });
    } else {
        document.getElementById('providerForm').classList.add('hide');
        document.getElementById('SGNLErrorText').classList.remove('hide');
    }
}

function AddToPTA(pta) {
    document.getElementById("ptaLicenseType").innerHTML = pta.licenseType || '';
    document.getElementById("ptaExchange").innerHTML = pta.exchange || '';
    document.getElementById("ptaApiKeys").innerHTML = pta.totalApiKeysAllowed + ' (' + Object.keys(pta.apiKeys).length + ' ' + i18next.t('accountPage.PTAssistant.used') + ')' || 0;
    document.getElementById("ptaExtraSlots").innerHTML = pta.totalExtraSlots || 0;
    document.getElementById("ptaConfigAllowed").innerHTML = pta.totalConfigs + ' (' + pta.totalConfigsUsed + ' ' + i18next.t('accountPage.PTAssistant.used') + ')' || 0;

    if (pta.lifetime) {
        document.getElementById("ptaExpirationDate").innerHTML = 'Lifetime';
    } else {
        document.getElementById("ptaExpirationDate").innerHTML = pta.expirationDate || '';
    }

    // Create Table with Keys
    var table = document.getElementById("PTAApiKeyTables");
    while (table.hasChildNodes()) {
        table.removeChild(table.firstChild);
    }

    headers = ['#', i18next.t('accountPage.PTAssistant.currentApiKey.key'), i18next.t('accountPage.PTAssistant.currentApiKey.lastActiveTime')];
    thead = document.createElement('thead');
    theadtr = document.createElement('tr');
    for (let i = 0; i < 3; i++) {
        th = document.createElement('th');
        th.appendChild(document.createTextNode(headers[i]));
        theadtr.appendChild(th);
    }
    thead.appendChild(theadtr);
    table.append(thead);

    var tbody = document.createElement("tbody");
    table.appendChild(tbody);

    Object.keys(pta.apiKeys).forEach(function (key, index) {
        tr = document.createElement('tr');
        for (let i = 0; i < 3; i++) {
            td = document.createElement('td');
            switch (i) {
                case 0:
                    td.appendChild(document.createTextNode(index + 1));
                    break;
                case 1:
                    td.className = key === pta.currentApiKey ? 'text-center current-key' : 'text-center';
                    let sKey = key.substr(0, 4) + '*******************' + key.slice(-4);
                    td.appendChild(document.createTextNode(sKey));
                    break;
                case 2:
                    let date = DateTimeHelper.formatDate(new Date(pta.apiKeys[key] * 1000));
                    td.appendChild(document.createTextNode(date));
                    break;
            }

            tr.appendChild(td);
        }
        tbody.appendChild(tr);
    })
}

function SaveSettings(data) {
    jQuery.ajax({
        type: 'POST',
        url: THE_BASE_URL + '/api/v2/account/settings',
        data: JSON.stringify(data),
        complete: function (xhr) {
            if(xhr.status === 304) {
                toastr.error(xhr.statusText);
            } else {
                toastr.success(i18next.t('accountPage.settingsSaved'));
                for (const [key, value] of Object.entries(data)) {
                    settings[key] = value;
                }
                initializeAccount(settings, propertiesLogData);
            }
        },
        error: function (data) {
            toastr.error(i18next.t('accountPage.settingSaveError'));
        },
        contentType: "application/json",
    });


}


function CreatApiString(length) {
    let result = '';
    let characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    let charactersLength = characters.length;
    for (let i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }

    document.getElementById("ApiToken").value = result;
}


function submitSettingAccountForm(e) {
    e.preventDefault();
    let settingsObj = {};

    document.getElementById("Port").value !== settings.PORT ? settingsObj.PORT = document.getElementById("Port").value : null;
    document.getElementById("SiteName").value !== settings.SITE_NAME ? settingsObj.SITE_NAME = document.getElementById("SiteName").value : null;
    document.getElementById("ApiToken").value !== settings.TOKEN ? settingsObj.TOKEN = document.getElementById("ApiToken").value : null;
    document.getElementById("ServerAddress").value !== settings.SERVER_ADDRESS ? settingsObj.SERVER_ADDRESS = document.getElementById("ServerAddress").value : null;
    document.getElementById("ServerContextPath").value !== settings.CONTEXT_PATH ? settingsObj.CONTEXT_PATH = document.getElementById("ServerContextPath").value : null;
    document.getElementById("ExchangeURL").value !== settings.EXCHANGE_URL ? settingsObj.EXCHANGE_URL = document.getElementById("ExchangeURL").value : null;
    document.getElementById("LogHistory").value !== settings.LOG_HISTORY ? settingsObj.LOG_HISTORY = document.getElementById("LogHistory").value : null;
    document.getElementById("PTFeederLocation").value !== settings.PTFEEDER ? settingsObj.PTFEEDER = document.getElementById("PTFeederLocation").value : null;

    String(document.getElementById("TestMode").checked) !== settings.TEST_MODE ? settingsObj.TEST_MODE = String(document.getElementById("TestMode").checked) : null;
    String(document.getElementById("TestNet").checked) !== settings.TEST_NET ? settingsObj.TEST_NET = String(document.getElementById("TestNet").checked) : null;
    String(document.getElementById("MarginTrading").checked) !== settings.MARGIN_TRADING ? settingsObj.MARGIN_TRADING = String(document.getElementById("MarginTrading").checked) : null;

    if (!_.isEmpty(settingsObj)) {
        Swal.fire({
            title: i18next.t('accountPage.saveServerSettings'),
            text: i18next.t('accountPage.reloadOrRefresh'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            return result.value ? SaveSettings(settingsObj) : null;
        })
    } else {
        toastr.error(i18next.t('accountPage.notChanged'));
    }

}

function submitUserAccountForm(e) {
    e.preventDefault();
    let settingsObj = {};

    document.getElementById("StartBalance").value !== settings.START_BALANCE ? settingsObj.START_BALANCE = document.getElementById("StartBalance").value : null;
    document.getElementById("ProfitCalculationMethod").value !== settings.PCM ? settingsObj.PCM = document.getElementById("ProfitCalculationMethod").value : null;
    document.getElementById("TradingDelay").value !== settings.START_TRADING_DELAY ? settingsObj.START_TRADING_DELAY = document.getElementById("TradingDelay").value : null;
    document.getElementById("Timezone").value !== settings.TIMEZONE ? settingsObj.TIMEZONE = document.getElementById("Timezone").value : null;
    document.getElementById("Skin").value !== settings.SKIN ? settingsObj.SKIN = document.getElementById("Skin").value : null;
    document.getElementById("Currency").value !== settings.CURRENCY ? settingsObj.CURRENCY = document.getElementById("Currency").value : null;
    document.getElementById("Language").value !== settings.LANGUAGE ? settingsObj.LANGUAGE = document.getElementById("Language").value : null;
    document.getElementById("SellType").value !== settings.SELL_ORDER_TYPE_OR_TIME ? settingsObj.SELL_ORDER_TYPE_OR_TIME = document.getElementById("SellType").value : null;
    document.getElementById("BuyType").value !== settings.BUY_ORDER_TYPE_OR_TIME ? settingsObj.BUY_ORDER_TYPE_OR_TIME = document.getElementById("BuyType").value : null;

    document.getElementById("TestModeBalance").value !== settings.TEST_MODE_BALANCE ? settingsObj.TEST_MODE_BALANCE = document.getElementById("TestModeBalance").value : null;

    String(document.getElementById("AdvStats").checked) !== settings.DISPLAY_ADVANCED_STATS ? settingsObj.DISPLAY_ADVANCED_STATS = String(document.getElementById("AdvStats").checked) : null;
    String(document.getElementById("DisableOfflineConfig").checked) !== settings.OFFLINE_CONFIG ? settingsObj.OFFLINE_CONFIG = String(document.getElementById("DisableOfflineConfig").checked) : null;
    String(document.getElementById("DisableNotifications").checked) !== settings.NOTIFICATION_BELL ? settingsObj.NOTIFICATION_BELL = String(document.getElementById("DisableNotifications").checked) : null;
    String(document.getElementById("OpenBrowser").checked) !== settings.BROWSER ? settingsObj.BROWSER = String(document.getElementById("OpenBrowser").checked) : true;

    if (!_.isEmpty(settingsObj)) {
        Swal.fire({
            title: i18next.t('accountPage.saveUserSettings'),
            text: i18next.t('accountPage.reloadOrRefresh'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            return result.value ? SaveSettings(settingsObj) : null;
        });
    } else {
        toastr.error(i18next.t('accountPage.notChanged'));
    }
}

function submitNotificationsAccountForm(e) {
    e.preventDefault();
    let settingsObj = {};

    String(document.getElementById("AdvancedNotifications").checked) !== settings.ADVANCED_NOTIFICATIONS ? settingsObj.ADVANCED_NOTIFICATIONS = String(document.getElementById("AdvancedNotifications").checked) : null;
    document.getElementById("TelegramBotToken1").value !== settings.TELEGRAM_TOKEN_1 ? settingsObj.TELEGRAM_TOKEN_1 = document.getElementById("TelegramBotToken1").value : null;
    document.getElementById("TelegramBotChatID1").value !== settings.TELEGRAM_CHAT_1 ? settingsObj.TELEGRAM_CHAT_1 = document.getElementById("TelegramBotChatID1").value : null;
    document.getElementById("TelegramSellMessage1").value !== settings.PTN_TELEGRAM_SELL_MESSAGE_1 ? settingsObj.PTN_TELEGRAM_SELL_MESSAGE_1 = document.getElementById("TelegramSellMessage1").value : null;
    document.getElementById("TelegramBuyMessage1").value !== settings.PTN_TELEGRAM_BUY_MESSAGE_1 ? settingsObj.PTN_TELEGRAM_BUY_MESSAGE_1 = document.getElementById("TelegramBuyMessage1").value : null;
    document.getElementById("TelegramErrorMessage1").value !== settings.PTN_TELEGRAM_ERROR_MESSAGES_FILTER_1 ? settingsObj.PTN_TELEGRAM_ERROR_MESSAGES_FILTER_1 = document.getElementById("TelegramErrorMessage1").value : null;

    document.getElementById("TelegramBotToken2").value !== settings.TELEGRAM_TOKEN_2 ? settingsObj.TELEGRAM_TOKEN_2 = document.getElementById("TelegramBotToken2").value : null;
    document.getElementById("TelegramBotChatID2").value !== settings.TELEGRAM_CHAT_2 ? settingsObj.TELEGRAM_CHAT_2 = document.getElementById("TelegramBotChatID2").value : null;
    document.getElementById("TelegramSellMessage2").value !== settings.PTN_TELEGRAM_SELL_MESSAGE_2 ? settingsObj.PTN_TELEGRAM_SELL_MESSAGE_2 = document.getElementById("TelegramSellMessage2").value : null;
    document.getElementById("TelegramBuyMessage2").value !== settings.PTN_TELEGRAM_BUY_MESSAGE_2 ? settingsObj.PTN_TELEGRAM_BUY_MESSAGE_2 = document.getElementById("TelegramBuyMessage2").value : null;
    document.getElementById("TelegramErrorMessage2").value !== settings.PTN_TELEGRAM_ERROR_MESSAGES_FILTER_2 ? settingsObj.PTN_TELEGRAM_ERROR_MESSAGES_FILTER_2 = document.getElementById("TelegramErrorMessage2").value : null;

    String(document.getElementById("TelegramSignalNotification").checked) !== settings.TELEGRAM_SIGNAL_NOTIFICATION ? settingsObj.TELEGRAM_SIGNAL_NOTIFICATION = String(document.getElementById("TelegramSignalNotification").checked) : null;
    String(document.getElementById("TelegramStartupNotification").checked) !== settings.TELEGRAM_STARTUP_NOTIFICATION ? settingsObj.TELEGRAM_STARTUP_NOTIFICATION = String(document.getElementById("TelegramStartupNotification").checked) : null;
    String(document.getElementById("TelegramShutdownNotification").checked) !== settings.TELEGRAM_SHUTDOWN_NOTIFICATION ? settingsObj.TELEGRAM_SHUTDOWN_NOTIFICATION = String(document.getElementById("TelegramShutdownNotification").checked) : null;
    String(document.getElementById("TelegramSellMessageEnabled1").checked) !== settings.PTN_TELEGRAM_SELL_MESSAGE_ENABLED_1 ? settingsObj.PTN_TELEGRAM_SELL_MESSAGE_ENABLED_1 = String(document.getElementById("TelegramSellMessageEnabled1").checked) : null;
    String(document.getElementById("TelegramBuyMessageEnabled1").checked) !== settings.PTN_TELEGRAM_BUY_MESSAGE_ENABLED_1 ? settingsObj.PTN_TELEGRAM_BUY_MESSAGE_ENABLED_1 = String(document.getElementById("TelegramBuyMessageEnabled1").checked) : null;
    String(document.getElementById("TelegramErrorMessageEnabled1").checked) !== settings.PTN_TELEGRAM_ERROR_MESSAGES_ENABLED_1 ? settingsObj.PTN_TELEGRAM_ERROR_MESSAGES_ENABLED_1 = String(document.getElementById("TelegramErrorMessageEnabled1").checked) : null;
    String(document.getElementById("TelegramCommandMessageEnabled1").checked) !== settings.PTN_TELEGRAM_COMMANDS_ENABLED_1 ? settingsObj.PTN_TELEGRAM_COMMANDS_ENABLED_1 = String(document.getElementById("TelegramCommandMessageEnabled1").checked) : null;
    String(document.getElementById("TelegramSellMessageEnabled2").checked) !== settings.PTN_TELEGRAM_SELL_MESSAGE_ENABLED_2 ? settingsObj.PTN_TELEGRAM_SELL_MESSAGE_ENABLED_2 = String(document.getElementById("TelegramSellMessageEnabled2").checked) : null;
    String(document.getElementById("TelegramBuyMessageEnabled2").checked) !== settings.PTN_TELEGRAM_BUY_MESSAGE_ENABLED_2 ? settingsObj.PTN_TELEGRAM_BUY_MESSAGE_ENABLED_2 = String(document.getElementById("TelegramBuyMessageEnabled2").checked) : null;
    String(document.getElementById("TelegramErrorMessageEnabled2").checked) !== settings.PTN_TELEGRAM_ERROR_MESSAGES_ENABLED_2 ? settingsObj.PTN_TELEGRAM_ERROR_MESSAGES_ENABLED_2 = String(document.getElementById("TelegramErrorMessageEnabled2").checked) : null;
    String(document.getElementById("TelegramCommandMessageEnabled2").checked) !== settings.PTN_TELEGRAM_COMMANDS_ENABLED_2 ? settingsObj.PTN_TELEGRAM_COMMANDS_ENABLED_2 = String(document.getElementById("TelegramCommandMessageEnabled2").checked) : null;


    document.getElementById("DiscordBotToken1").value !== settings.DISCORD_TOKEN_1 ? settingsObj.DISCORD_TOKEN_1 = document.getElementById("DiscordBotToken1").value : null;
    document.getElementById("DiscordBotChatID1").value !== settings.DISCORD_CHAT_1 ? settingsObj.DISCORD_CHAT_1 = document.getElementById("DiscordBotChatID1").value : null;
    document.getElementById("DiscordSellMessage1").value !== settings.PTN_DISCORD_SELL_MESSAGE_1 ? settingsObj.PTN_DISCORD_SELL_MESSAGE_1 = document.getElementById("DiscordSellMessage1").value : null;
    document.getElementById("DiscordBuyMessage1").value !== settings.PTN_DISCORD_BUY_MESSAGE_1 ? settingsObj.PTN_DISCORD_BUY_MESSAGE_1 = document.getElementById("DiscordBuyMessage1").value : null;
    document.getElementById("DiscordErrorMessage1").value !== settings.PTN_DISCORD_ERROR_MESSAGES_FILTER_1 ? settingsObj.PTN_DISCORD_ERROR_MESSAGES_FILTER_1 = document.getElementById("DiscordErrorMessage1").value : null;

    document.getElementById("DiscordBotToken2").value !== settings.DISCORD_TOKEN_2 ? settingsObj.DISCORD_TOKEN_2 = document.getElementById("DiscordBotToken2").value : null;
    document.getElementById("DiscordBotChatID2").value !== settings.DISCORD_CHAT_2 ? settingsObj.DISCORD_CHAT_2 = document.getElementById("DiscordBotChatID2").value : null;
    document.getElementById("DiscordSellMessage2").value !== settings.PTN_DISCORD_SELL_MESSAGE_2 ? settingsObj.PTN_DISCORD_SELL_MESSAGE_2 = document.getElementById("DiscordSellMessage2").value : null;
    document.getElementById("DiscordBuyMessage2").value !== settings.PTN_DISCORD_BUY_MESSAGE_2 ? settingsObj.PTN_DISCORD_BUY_MESSAGE_2 = document.getElementById("DiscordBuyMessage2").value : null;
    document.getElementById("DiscordErrorMessage2").value !== settings.PTN_DISCORD_ERROR_MESSAGES_FILTER_2 ? settingsObj.PTN_DISCORD_ERROR_MESSAGES_FILTER_2 = document.getElementById("DiscordErrorMessage2").value : null;

    document.getElementById("DiscordNewSignalChannel").value !== settings.DISCORD_SIGNAL_NOTIFICATION_CHANNEL ? settingsObj.DISCORD_SIGNAL_NOTIFICATION_CHANNEL = document.getElementById("DiscordNewSignalChannel").value : null;

    String(document.getElementById("DiscordSignalNotification").checked) !== settings.DISCORD_SIGNAL_NOTIFICATION ? settingsObj.DISCORD_SIGNAL_NOTIFICATION = String(document.getElementById("DiscordSignalNotification").checked) : null;
    String(document.getElementById("DiscordStartupNotification").checked) !== settings.DISCORD_STARTUP_NOTIFICATION ? settingsObj.DISCORD_STARTUP_NOTIFICATION = String(document.getElementById("DiscordStartupNotification").checked) : null;
    String(document.getElementById("DiscordShutdownNotification").checked) !== settings.DISCORD_SHUTDOWN_NOTIFICATION ? settingsObj.DISCORD_SHUTDOWN_NOTIFICATION = String(document.getElementById("DiscordShutdownNotification").checked) : null;
    String(document.getElementById("DiscordSellMessageEnabled1").checked) !== settings.PTN_DISCORD_SELL_MESSAGE_ENABLED_1 ? settingsObj.PTN_DISCORD_SELL_MESSAGE_ENABLED_1 = String(document.getElementById("DiscordSellMessageEnabled1").checked) : null;
    String(document.getElementById("DiscordBuyMessageEnabled1").checked) !== settings.PTN_DISCORD_BUY_MESSAGE_ENABLED_1 ? settingsObj.PTN_DISCORD_BUY_MESSAGE_ENABLED_1 = String(document.getElementById("DiscordBuyMessageEnabled1").checked) : null;
    String(document.getElementById("DiscordErrorMessageEnabled1").checked) !== settings.PTN_DISCORD_ERROR_MESSAGES_ENABLED_1 ? settingsObj.PTN_DISCORD_ERROR_MESSAGES_ENABLED_1 = String(document.getElementById("DiscordErrorMessageEnabled1").checked) : null;
    String(document.getElementById("DiscordCommandMessageEnabled1").checked) !== settings.PTN_DISCORD_COMMANDS_ENABLED_1 ? settingsObj.PTN_DISCORD_COMMANDS_ENABLED_1 = String(document.getElementById("DiscordCommandMessageEnabled1").checked) : null;
    String(document.getElementById("DiscordSellMessageEnabled2").checked) !== settings.PTN_DISCORD_SELL_MESSAGE_ENABLED_2 ? settingsObj.PTN_DISCORD_SELL_MESSAGE_ENABLED_2 = String(document.getElementById("DiscordSellMessageEnabled2").checked) : null;
    String(document.getElementById("DiscordBuyMessageEnabled2").checked) !== settings.PTN_DISCORD_BUY_MESSAGE_ENABLED_2 ? settingsObj.PTN_DISCORD_BUY_MESSAGE_ENABLED_2 = String(document.getElementById("DiscordBuyMessageEnabled2").checked) : null;
    String(document.getElementById("DiscordErrorMessageEnabled2").checked) !== settings.PTN_DISCORD_ERROR_MESSAGES_ENABLED_2 ? settingsObj.PTN_DISCORD_ERROR_MESSAGES_ENABLED_2 = String(document.getElementById("DiscordErrorMessageEnabled2").checked) : null;
    String(document.getElementById("DiscordCommandMessageEnabled2").checked) !== settings.PTN_DISCORD_COMMANDS_ENABLED_2 ? settingsObj.PTN_DISCORD_COMMANDS_ENABLED_2 = String(document.getElementById("DiscordCommandMessageEnabled2").checked) : null;

    if (!_.isEmpty(settingsObj)) {
        Swal.fire({
            title: i18next.t('accountPage.saveNotificationSettings'),
            text: i18next.t('accountPage.reloadOrRefresh'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            return result.value ? SaveSettings(settingsObj) : null;
        });
    } else {
        toastr.error(i18next.t('accountPage.notChanged'));
    }
}

function submitProviderSettings(e) {
    e.preventDefault();
    let providerString = [];
    let settingsObj = {};

    $('.signalProviders > input').each(function () {
        if (document.getElementById($(this).attr('id')).checked) {
            providerString.push($(this).attr('id'));
        }
    });

    settingsObj.SELECTED_SIGNAL_PROVIDERS = providerString.toString();
    Swal.fire({
        title: i18next.t('accountPage.saveProviderSettings'),
        text: i18next.t('accountPage.reloadOrRefresh'),
        type: "warning",
        showCancelButton: true,
        cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
        confirmButtonColor: '#DD6B55',
        confirmButtonText: i18next.t('alertMsgs.submitBtn'),
        reverseButtons: true,
    }).then(result => {
        return result.value ? SaveSettings(settingsObj) : null;
    });

}

function submitSSLAccountForm(e) {
    e.preventDefault();
    let settingsObj = {};

    document.getElementById("SSLKeyStore").value !== settings.SSL_KEY_STORE ? settingsObj.SSL_KEY_STORE = document.getElementById("SSLKeyStore").value : null;
    document.getElementById("SSLKeyStorePassword").value !== settings.SSL_KEY_STORE_PASSWORD ? settingsObj.SSL_KEY_STORE_PASSWORD = document.getElementById("SSLKeyStorePassword").value : null;
    document.getElementById("SSLKeyPassword").value !== settings.SSL_KEY_PASSWORD ? settingsObj.SSL_KEY_PASSWORD = document.getElementById("SSLKeyPassword").value : null;
    document.getElementById("SSLKeyStoreType").value !== settings.SSL_KEY_STORE_TYPE ? settingsObj.SSL_KEY_STORE_TYPE = document.getElementById("SSLKeyStoreType").value : null;
    document.getElementById("SSLKeyAlias").value !== settings.SSL_KEY_ALIAS ? settingsObj.SSL_KEY_ALIAS = document.getElementById("SSLKeyAlias").value : null;

    if (!_.isEmpty(settingsObj)) {
        Swal.fire({
            title: i18next.t('accountPage.saveSSLSettings'),
            text: i18next.t('accountPage.reloadOrRefresh'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            return result.value ? SaveSettings(settingsObj) : null;
        });
    } else {
        toastr.error(i18next.t('accountPage.notChanged'));
    }
}

function testNotificationSettings(e, provider, number) {
    e.preventDefault();

    if (provider === "TELEGRAM") {
        let token;
        let chatId;
        switch (number) {
            case 1:
                chatId = document.getElementById("TelegramBotChatID1").value;
                token = document.getElementById("TelegramBotToken1").value;
                break;
            case 2:
                chatId = document.getElementById("TelegramBotChatID2").value;
                token = document.getElementById("TelegramBotToken2").value;
                break;
            case 3:
                chatId = document.getElementById("TelegramBotChatID3").value;
                token = document.getElementById("TelegramBotToken3").value;
                break;
            case 4:
                chatId = document.getElementById("TelegramBotChatID4").value;
                token = document.getElementById("TelegramBotToken4").value;
                break;
            case 5:
                chatId = document.getElementById("TelegramBotChatID5").value;
                token = document.getElementById("TelegramBotToken5").value;
                break;
            default:
                chatId = null;
                token = null;
        }

        if (token && chatId) {
            jQuery.post(THE_BASE_URL + '/api/v2/messaging/testmessage?token=' + token + '&chatId=' + chatId + '&platform=TELEGRAM')
                .done(function (data, textStatus, xhr) {
                    if (xhr.status === 204) {
                        toastr.success(i18next.t('accountPage.notificationAlerts.success'));
                    } else {
                        toastr.error(i18next.t('accountPage.notificationAlerts.error'));
                    }
                })
                .fail(function () {
                    toastr.error(i18next.t('accountPage.notificationAlerts.error'));
                })
        } else {
            toastr.error(i18next.t('accountPage.notificationAlerts.empty'));
        }
    }

    if (provider === "DISCORD") {
        let chatId;
        let token;
        switch (number) {
            case 1:
                chatId = document.getElementById("DiscordBotChatID1").value;
                token = document.getElementById("DiscordBotToken1").value;
                break;
            case 2:
                chatId = document.getElementById("DiscordBotChatID2").value;
                token = document.getElementById("DiscordBotToken2").value;
                break;
            case 3:
                chatId = document.getElementById("DiscordBotChatID3").value;
                token = document.getElementById("DiscordBotToken3").value;
                break;
            case 4:
                chatId = document.getElementById("DiscordBotChatID4").value;
                token = document.getElementById("DiscordBotToken4").value;
                break;
            case 5:
                chatId = document.getElementById("DiscordBotChatID5").value;
                token = document.getElementById("DiscordBotToken5").value;
                break;
            default:
                chatId = null;
                token = null;
        }

        if (token && chatId) {
            jQuery.post(THE_BASE_URL + '/api/v2/messaging/testmessage?token=' + token + '&chatId=' + chatId + '&platform=DISCORD')
                .done(function (data, textStatus, xhr) {
                    if (xhr.status === 204) {
                        toastr.success(i18next.t('accountPage.notificationAlerts.success'));
                    } else {
                        toastr.error(i18next.t('accountPage.notificationAlerts.error'));
                    }
                })
                .fail(function () {
                    toastr.error(i18next.t('accountPage.notificationAlerts.error'));
                })
        } else {
            toastr.error(i18next.t('accountPage.notificationAlerts.empty'));
        }
    }
}


function RedeemVoucher(e) {
    e.preventDefault();
    let options = ['LICENSE_UPGRADE', 'APISLOT', 'CONFIG', 'SIGNAL'];

    let voucher = document.getElementById("PTAReedemVoucherInput").value;
    let selection = document.getElementById("PTAReedemVoucherSelect").value;

    if (voucher && options.includes(selection)) {
        Swal.fire({
            title: i18next.t('accountPage.PTAssistant.toastr.voucherTitle'),
            text: i18next.t('accountPage.PTAssistant.toastr.voucherText'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            if (result.value) {
                jQuery.post(THE_BASE_URL + '/api/v2/assistant/redeem?voucherCode=' + voucher + '&voucherType=' + selection)
                    .done(function (data, textStatus, xhr) {
                        if (xhr.status === 204) {
                            toastr.success(i18next.t('accountPage.PTAssistant.toastr.voucherSuccess'));
                            initializeAccount(arrayData);
                        } else {
                            toastr.error(xhr.statusText);
                        }
                    })
                    .fail(function () {
                        toastr.error(i18next.t('accountPage.PTAssistant.toastr.somethingWrong'));
                    })
            }
        });
    } else {
        toastr.error(i18next.t('accountPage.PTAssistant.toastr.specifyVoucher'));
    }

}